--
-- Copyright (C) 2012-2016 Snail <https://github.com/snail23/snailui/>
--
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation; either version 2 of the License, or (at your
-- option) any later version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
-- more details.
--
-- You should have received a copy of the GNU General Public License along
-- with this program. If not, see <http://www.gnu.org/licenses/>.
--

function HandleClassBar(Self, Type)
	Type = Type .. "Bar"

	local Class = select(2, UnitClass(Self.Frame))
	local Specialization = GetSpecialization()

	if Specialization then
		Specialization = select(2, GetSpecializationInfo(Specialization))
		Specialization = Specialization:gsub("(.)", string.upper)
	end

	if GetConfiguration()[Self.Frame][Type] and (Self.Frame == "Player") and (((Class == "MONK") and (Type == "ChiBar")) or ((Class == "PALADIN") and (Type == "HolyPowerBar")) or ((Class == "PRIEST") and (Specialization == "SHADOW") and (Type == "ShadowOrbsBar")) or ((Class == "WARLOCK") and (Specialization == "AFFLICTION") and (Type == "SoulShardsBar"))) then
		Self.ClassIcons = Self:CreateTexture(Self, "BACKGROUND")
		Self.ClassIcons:SetSize(GetConfiguration()[Self.Frame][Type].Width, GetConfiguration()[Self.Frame][Type].Height)
		Self.ClassIcons:SetTexture(0, 0, 0)

		if GetConfiguration()[Self.Frame][Type].Parent then
			Self.ClassIcons:SetPoint(GetConfiguration()[Self.Frame][Type].Anchor, GetConfiguration()[Self.Frame][Type].Parent, GetConfiguration()[Self.Frame][Type].X, GetConfiguration()[Self.Frame][Type].Y)
		else
			Self.ClassIcons:SetPoint(GetConfiguration()[Self.Frame][Type].Anchor, GetConfiguration()[Self.Frame][Type].X, GetConfiguration()[Self.Frame][Type].Y)
		end

		Self.ClassIcons.Background = Self:CreateTexture(nil, "BACKGROUND")
		Self.ClassIcons.Background:SetPoint("TOPLEFT", Self.ClassIcons, 1, -1)
		Self.ClassIcons.Background:SetSize(GetConfiguration()[Self.Frame][Type].Width - 2, GetConfiguration()[Self.Frame][Type].Height - 2)
		Self.ClassIcons.Background:SetTexture(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)
		
		Self.ClassIcons.UpdateTexture = Blank

		for I = 1, #GetConfiguration()[Self.Frame][Type] do
			Self.ClassIcons[I] = Self:CreateTexture(Self, "LOW")			
			Self.ClassIcons[I]:SetPoint(GetConfiguration()[Self.Frame][Type][I].Anchor, Self.ClassIcons, GetConfiguration()[Self.Frame][Type][I].X, GetConfiguration()[Self.Frame][Type][I].Y)
			Self.ClassIcons[I]:SetSize(GetConfiguration()[Self.Frame][Type][I].Width - 2, GetConfiguration()[Self.Frame][Type][I].Height - 2)
			Self.ClassIcons[I]:SetTexture(Configuration.Texture)
			Self.ClassIcons[I]:SetVertexColor(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)

			SmoothBar(Self.ClassIcons, Self.ClassIcons[I])

			Self.ClassIcons[I].Border = Self:CreateTexture(nil, "LOW")
			Self.ClassIcons[I].Border:SetPoint("TOPLEFT", Self.ClassIcons[I], -1, 1)
			Self.ClassIcons[I].Border:SetSize(GetConfiguration()[Self.Frame][Type][I].Width, GetConfiguration()[Self.Frame][Type][I].Height)
			Self.ClassIcons[I].Border:SetTexture(0, 0, 0)
		end
	end
end
